package{
  import flash.display.Graphics;
  import flash.display.GraphicsPathCommand;
  import figure.Point3D;
  import figure.SphericalAngle;

//--------------------------------------------------------------------//
// ubNNX Cݐ - GA - ubN - _
  public class GlobeBlock{

// ubN
    public var name:String;

// _Xg
    public var list:Vector.<GlobePoint>;

// `R}h
    internal var commands:Vector.<int>;

// `W
    internal var coords:Vector.<Number>;

// name - ubN
// size - _̐
    public function GlobeBlock(name:String,size:int){
      this.name=name;
      list=new Vector.<GlobePoint>(size,true);
    }

//--------------------------------------------------------------------//
// _̐Ԃ
    public function getSize():int{
      return list.length;
    }

//--------------------------------------------------------------------//
// _Ԃ
// index - _̃CfbNX
    public function get(index:int):GlobePoint{
      return list[index];
    }

//--------------------------------------------------------------------//
// _ݒ肷
// index - _̃CfbNX
// p - ݒ肷_
    public function set(index:int,p:GlobePoint):void{
      list[index]=p;
    }

//--------------------------------------------------------------------//
// `f[^
    public function init():void{
      commands=new Vector.<int>(list.length,true);
      coords=new Vector.<Number>(2*list.length,true);
    }

//--------------------------------------------------------------------//
// Cݐ`悷 (nV[h)
// graphics - `OtBbNX
// sa - _px
// cx,cy - \Sʒu
// radius - nVa
    public function drawGlobe(graphics:Graphics,sa:SphericalAngle,
      	      	      	      cx:int,cy:int,radius:int):void{
      var prevp:Point3D=new Point3D();
      for(var i:int=0;i<list.length;i++){
      	var vp:Point3D=list[i].getGlobe(cx,cy,radius,sa);
      	coords[2*i]=vp.x;
      	coords[2*i+1]=vp.y;
      	if(i==0){
      	  commands[i]=GraphicsPathCommand.MOVE_TO;
      	}
      	else if(prevp.z>=0 && vp.z>=0){
      	  commands[i]=GraphicsPathCommand.LINE_TO;
      	}
      	else{
      	  commands[i]=GraphicsPathCommand.MOVE_TO;
      	}
      	prevp=vp;
      }
      graphics.drawPath(commands,coords);
    }

//--------------------------------------------------------------------//
// Cݐ`悷 (~}@[h)
// graphics - `OtBbNX
// cx,cy - \Sʒu
// coefX/coefY - ox/ܓxWϊW
// thetaX - _̌ox
    public function drawECP(graphics:Graphics,cx:int,cy:int,
      	      	      	    coefX:Number,coefY:Number,thetaX:Number)
      	      	      	   :void{
      var prevp:Point3D=new Point3D();
      for(var i:int=0;i<list.length;i++){
      	var vp:Point3D=list[i].getECP(cx,cy,coefX,coefY,thetaX);
      	coords[2*i]=vp.x;
      	coords[2*i+1]=vp.y;
      	if(i==0){
      	  commands[i]=GraphicsPathCommand.MOVE_TO;
      	}
      	else if(Math.abs(prevp.x-vp.x)<=cx){
      	  commands[i]=GraphicsPathCommand.LINE_TO;
      	}
      	else{
      	  commands[i]=GraphicsPathCommand.MOVE_TO;
      	}
      	prevp=vp;
      }
      graphics.drawPath(commands,coords);
    }
  }
}
