package{
  import flash.display.Graphics;
  import figure.Point3D;
  import figure.SphericalAngle;

//--------------------------------------------------------------------//
// ssf[^f
  public class GlobeCityModel{

// sXg
    public var capitalList:Vector.<GlobeCity>;

// ssXg
    public var cityList:Vector.<GlobeCity>;

// ss}[N\TCY
    internal var rect:int=2;

    public function GlobeCityModel(){
      capitalList=new Vector.<GlobeCity>();
      cityList=new Vector.<GlobeCity>();
    }

//--------------------------------------------------------------------//
// sǉ
// capital - ǉs
    public function addCapital(capital:GlobeCity):void{
      capitalList.push(capital);
    }

//--------------------------------------------------------------------//
// ssǉ
// city - ǉss
    public function addCity(city:GlobeCity):void{
      cityList.push(city);
    }

//--------------------------------------------------------------------//
// NbNssԂ
// x,y - }EXʒu
    public function click(x:int,y:int):Array{
      for(var i:int=0;i<capitalList.length;i++){
      	if(capitalList[i].click(x,y,rect)){
      	  return [capitalList[i],GlobeCityPointer.CAPITAL];
      	}
      }
      for(i=0;i<cityList.length;i++){
      	if(cityList[i].click(x,y,rect)){
      	  return [cityList[i],GlobeCityPointer.CITY];
      	}
      }
      return [null,GlobeCityPointer.NONE];
    }

//--------------------------------------------------------------------//
// ss`悷
// graphics - `OtBbNX
// viewMode - \[h
// sa - _px
// thetaX - _̌ox
// cx,cy - \Sʒu
// radius - nVa
// capitalColor - s\F
// cityColor - ss\F
    public function draw(graphics:Graphics,viewMode:int,
      	      	      	 sa:SphericalAngle,thetaX:Number,
      	      	      	 cx:int,cy:int,radius:int,
      	      	      	 capitalColor:uint,cityColor:uint):void{
      switch(viewMode){
      	case GlobeViewModel.GLOBE:
      	  drawGlobe(graphics,sa,cx,cy,radius,capitalColor,cityColor);
      	  break;
      	case GlobeViewModel.ECP:
      	  drawECP(graphics,thetaX,cx,cy,radius,capitalColor,cityColor);
      	  break;
      }
    }

//--------------------------------------------------------------------//
// ss`悷 (nV[h)
// graphics - `OtBbNX
// sa - _px
// cx,cy - \Sʒu
// radius - nVa
// capitalColor - s\F
// cityColor - ss\F
    public function drawGlobe(graphics:Graphics,sa:SphericalAngle,
      	      	      	      cx:int,cy:int,radius:int,
      	      	      	      capitalColor:uint,cityColor:uint):void{
      graphics.lineStyle(0,cityColor);
      for(var i:int=0;i<cityList.length;i++){
      	cityList[i].getGlobe(cx,cy,radius,sa);
      	cityList[i].draw(graphics,rect,cityColor);
      }
      graphics.lineStyle(0,capitalColor);
      for(i=0;i<capitalList.length;i++){
      	capitalList[i].getGlobe(cx,cy,radius,sa);
      	capitalList[i].draw(graphics,rect,capitalColor);
      }
    }

//--------------------------------------------------------------------//
// ss`悷 (~}@[h)
// graphics - `OtBbNX
// thetaX - _̌ox
// cx,cy - \Sʒu
// radius - nVa
// capitalColor - s\F
// cityColor - ss\F
    public function drawECP(graphics:Graphics,thetaX:Number,
      	      	      	    cx:int,cy:int,radius:int,
      	      	      	    capitalColor:uint,cityColor:uint):void{
      var coefX:Number=cx/180.0;
      var coefY:Number=Math.min(cx,2*cy)/180.0;
      graphics.lineStyle(0,cityColor);
      for(var i:int=0;i<cityList.length;i++){
      	cityList[i].getECP(cx,cy,coefX,coefY,thetaX);
      	cityList[i].draw(graphics,rect,cityColor);
      }
      graphics.lineStyle(0,capitalColor);
      for(i=0;i<capitalList.length;i++){
      	capitalList[i].getECP(cx,cy,coefX,coefY,thetaX);
      	capitalList[i].draw(graphics,rect,capitalColor);
      }
    }
  }
}
