package{
  import flash.display.Sprite;
  import flash.events.Event;
  import flash.text.TextFormat;

  [SWF(width="300",height="300",backgroundColor="0xffffff")]

//--------------------------------------------------------------------//
// nV@CNX
  public class Globe extends Sprite{

// Cݐf[^f
    internal var mapModel:GlobeMapModel;

// ssf[^f
    internal var cityModel:GlobeCityModel;

// n}\f
    internal var view:GlobeViewModel;

// ANVǗNX
    internal var action:GlobeActionManager;

// html ̎擾p[^
    internal var vars:Object;

//--------------------------------------------------------------------//
    public function Globe(){
      vars=loaderInfo.parameters;
      mapModel=new GlobeMapModel();
      cityModel=new GlobeCityModel();
      var mapReader:GlobeMapReader=new GlobeMapReader();
      var cityReader:GlobeCityReader=new GlobeCityReader();

      mapReader.readData(vars["mapdata"],mapModel);
      mapReader.addEventListener(TableData.LOAD_COMPLETE,onTextLoaded1);

      function onTextLoaded1(event:Event):void{
      	cityReader.readData(vars["citydata"],cityModel);
      	cityReader.addEventListener(TableData.LOAD_COMPLETE,
      	      	      	      	    onTextLoaded2);
      }
    }

//--------------------------------------------------------------------//
// ǂݍ݊
    private function onTextLoaded2(event:Event):void{
      var textFormat:TextFormat=new TextFormat("Arial",12,0x000000);
      view=new GlobeViewModel(Sprite(this),mapModel,cityModel,graphics,
      	      	      	      0,0,300,270,
      	      	      	      uint("0x"+vars["backgroundcolor"]),
      	      	      	      uint("0x"+vars["linecolor"]),
      	      	      	      uint("0x"+vars["capitalcolor"]),
      	      	      	      uint("0x"+vars["citycolor"]),
      	      	      	      textFormat);
      action=new GlobeActionManager(Sprite(this),view,20,275,300,
      	      	      	      	    textFormat);
      view.draw();
    }
  }
}