package{
  import flash.display.Graphics;
  import figure.SphericalAngle;

//--------------------------------------------------------------------//
// Cݐf[^f Cݐ - GA - ubN - _
  public class GlobeMapModel{

// GAXg
    public var list:Vector.<GlobeArea>;

    public function GlobeMapModel(){
      list=new Vector.<GlobeArea>();
    }

//--------------------------------------------------------------------//
// GA̐Ԃ
    public function getSize():int{
      return list.length;
    }

//--------------------------------------------------------------------//
// GAԂ
// index - GÃCfbNX
    public function get(index:int):GlobeArea{
      return list[index];
    }

//--------------------------------------------------------------------//
// GAǉ
// area - ǉGA
    public function addArea(area:GlobeArea):void{
      list.push(area);
    }

//--------------------------------------------------------------------//
// `f[^
    public function init():void{
      for(var i:int=0;i<list.length;i++){
      	var blockCount:int=list[i].getSize();
      	for(var j:int=0;j<blockCount;j++){
      	  list[i].get(j).init();
      	}
      }
    }

//--------------------------------------------------------------------//
// Cݐ`悷
// graphics - `OtBbNX
// viewMode - \[h
// sa - _px
// thetaX - _̌ox
// cx,cy - \Sʒu
// radius - nVa
// lineColor - Cݐ\F
    public function draw(graphics:Graphics,viewMode:int,
      	      	      	 sa:SphericalAngle,thetaX:Number,cx:int,cy:int,
      	      	      	 radius:int,lineColor:uint):void{
      graphics.lineStyle(1,lineColor);
      switch(viewMode){
      	case GlobeViewModel.GLOBE:
      	  drawGlobe(graphics,sa,cx,cy,radius);
      	  break;
      	case GlobeViewModel.ECP:
      	  drawECP(graphics,thetaX,cx,cy,radius);
      	  break;
      }
    }

//--------------------------------------------------------------------//
// Cݐ`悷 (nV[h)
// graphics - `OtBbNX
// sa - _px
// cx,cy - \Sʒu
// radius - nVa
    public function drawGlobe(graphics:Graphics,sa:SphericalAngle,
      	      	      	      cx:int,cy:int,radius:int):void{
      graphics.drawCircle(cx,cy,radius);
      for(var i:int=0;i<list.length;i++){
      	list[i].drawGlobe(graphics,sa,cx,cy,radius);
      }
    }

//--------------------------------------------------------------------//
// Cݐ`悷 (~}@[h)
// graphics - `OtBbNX
// thetaX - _̌ox
// cx,cy - \Sʒu
// radius - nVa
    public function drawECP(graphics:Graphics,thetaX:Number,
      	      	      	    cx:int,cy:int,radius:int):void{
      var coefX:Number=cx/180.0;
      var coefY:Number=Math.min(cx,2*cy)/180.0;
      var border1:int=cy-int(90.0*coefY);
      var border2:int=cy+int(90.0*coefY);
      graphics.moveTo(0,border1);
      graphics.lineTo(2*cx,border1);
      graphics.moveTo(0,border2);
      graphics.lineTo(2*cx,border2);
      for(var i:int=0;i<list.length;i++){
      	list[i].drawECP(graphics,cx,cy,coefX,coefY,thetaX);
      }
    }
  }
}
